/****************************************************************************/
/*                                                                          */
/*              ݴӿƼ޹˾                                    */
/*                                                                          */
/*              Copyright 2015 Tronlong All rights reserved                 */
/*                                                                          */
/****************************************************************************/
/****************************************************************************/
/*                                                                          */
/*              װ LED                                                */
/*                                                                          */
/*              20150425                                              */
/*                                                                          */
/****************************************************************************/
#include "TL138.h"                 //  TL138 

#include "hw_types.h"               // 
#include "hw_syscfg0_OMAPL138.h"       // ϵͳģĴ
#include "soc_OMAPL138.h"              // OMAPL138 Ĵ

#include "psc.h"                    // Դ˯߿ƺ꼰豸㺯
#include "gpio.h"                   // ͨں꼰豸㺯
/****************************************************************************/
/*                                                                          */
/*              궨                                                      */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/*                                                                          */
/*              ȫֱ                                                    */
/*                                                                          */
/****************************************************************************/

/****************************************************************************/
/*                                                                          */
/*                                                                  */
/*                                                                          */
/****************************************************************************/
// ʹ
void PSCInit(void);
// GPIO ܽŸ
void GPIOBankPinMuxSet();
// GPIO ܽųʼ
void GPIOBankPinInit();
// ʱ
void Delay(unsigned int n);

/****************************************************************************/
/*                                                                          */
/*                                                                    */
/*                                                                          */
/****************************************************************************/
int main(void)
{
	// ʹ
	PSCInit();

	// GPIO ܽŸ
	GPIOBankPinMuxSet();

	// GPIO ܽųʼ
	GPIOBankPinInit();

	// ѭ
	for(;;)
	{
		// ʱ
		Delay(0x000FFFFF);
    	GPIOPinWrite(SOC_GPIO_0_REGS, 3, GPIO_PIN_LOW);    // D10  GPIO0[2]
		GPIOPinWrite(SOC_GPIO_0_REGS, 121, GPIO_PIN_HIGH);   // D7   GPIO0[0]

		// ʱ
		Delay(0x000FFFFF);
		GPIOPinWrite(SOC_GPIO_0_REGS, 121, GPIO_PIN_LOW);    // D7   GPIO0[0]
		GPIOPinWrite(SOC_GPIO_0_REGS, 6, GPIO_PIN_HIGH);   // D6   GPIO0[5]

		// ʱ
		Delay(0x000FFFFF);
		GPIOPinWrite(SOC_GPIO_0_REGS, 6, GPIO_PIN_LOW);    // D6   GPIO0[5]
		GPIOPinWrite(SOC_GPIO_0_REGS, 2, GPIO_PIN_HIGH);   // D9   GPIO0[1]

		// ʱ
		Delay(0x000FFFFF);
		GPIOPinWrite(SOC_GPIO_0_REGS, 2, GPIO_PIN_LOW);    // D9   GPIO0[1]
		GPIOPinWrite(SOC_GPIO_0_REGS, 3, GPIO_PIN_HIGH);   // D10  GPIO0[2]
	}
}

/****************************************************************************/
/*                                                                          */
/*              PSC ʼ                                                  */
/*                                                                          */
/****************************************************************************/
void PSCInit(void)
{
	// ʹ GPIO ģ
	// ӦģʹҲ BootLoader 
    PSCModuleControl(SOC_PSC_1_REGS, HW_PSC_GPIO, PSC_POWERDOMAIN_ALWAYS_ON, PSC_MDCTL_NEXT_ENABLE);
}

/****************************************************************************/
/*                                                                          */
/*              GPIO ܽŸ                                           */
/*                                                                          */
/****************************************************************************/
void GPIOBankPinMuxSet(void)
{
	// Ӧ GPIO ڹΪͨ
	// װ LED
	GPIOBank7Pin8PinMuxSetup();
	GPIOBank0Pin1PinMuxSetup();
	GPIOBank0Pin2PinMuxSetup();
	GPIOBank0Pin5PinMuxSetup();
}

/****************************************************************************/
/*                                                                          */
/*              GPIO ܽųʼ                                             */
/*                                                                          */
/****************************************************************************/
void GPIOBankPinInit(void)
{
	//  LED ӦܽΪܽ
    // OMAPL138  DSP C6748  144  GPIO
	// Ϊ GPIO BANK ʼܽŶӦֵ
    // Χ 1-144
	// GPIO0[0] 1
    // GPIO1[0] 17
	// GPIO2[0] 33
    // GPIO3[0] 49
	// GPIO4[0] 65
    // GPIO5[0] 81
	// GPIO6[0] 97
	// GPIO7[0] 113
	// GPIO8[0] 129

	// İ LED
    GPIODirModeSet(SOC_GPIO_0_REGS, 109, GPIO_DIR_OUTPUT);  // GPIO6[12]
    GPIODirModeSet(SOC_GPIO_0_REGS, 110, GPIO_DIR_OUTPUT);  // GPIO6[13]

    // װ LED
    GPIODirModeSet(SOC_GPIO_0_REGS, 121, GPIO_DIR_OUTPUT);    // D7  GPIO0[0]
    GPIODirModeSet(SOC_GPIO_0_REGS, 2, GPIO_DIR_OUTPUT);    // D9  GPIO0[1]
    GPIODirModeSet(SOC_GPIO_0_REGS, 3, GPIO_DIR_OUTPUT);    // D10 GPIO0[2]
    GPIODirModeSet(SOC_GPIO_0_REGS, 6, GPIO_DIR_OUTPUT);    // D6  GPIO0[5]
}

/****************************************************************************/
/*                                                                          */
/*              ʱ                                                        */
/*                                                                          */
/****************************************************************************/
void Delay(volatile unsigned int delay)
{
    while(delay--);
}
